<template>
  <v-layout>
    <v-flex xs12>
      <v-card class="mb-2" color="white">
        <v-toolbar color="blue lighten-3" dark height="50px">
          <v-toolbar-title>User Group : {{ xusergroup.name }}</v-toolbar-title>
          <v-spacer></v-spacer>
          <v-btn v-if="xusergroup.name !== '[ Belum memilih User Group ]'" @click="openFormUser(0)" icon>
            <v-icon>library_add</v-icon>
          </v-btn>
        </v-toolbar>

        <v-layout row wrap>
          <v-flex class="border-bottom-dashed" xs12 pt-2 pl-4 pr-4 pb-4>
            <table>
              <tr>
                <th width="25%" class="text-md-center pt-2 pb-2">USERNAME</th>
                <th width="35%" class="text-md-center pt-2 pb-2">STAFF NAME</th>
                <th class="text-md-center pt-2 pb-2">AKSI</th>
              </tr>
              <tr v-if="users.length > 0" v-for="(user, idx) in users">
                <td class="text-md-left pl-3">{{ user.username }}</td>
                <td class="text-md-center">{{ user.staffname }}</td>

                <td align="center" class="text-md-center">
                  <v-btn @click="resetPassword(user)" depressed small color="warning"><v-icon>security</v-icon></v-btn>
                  <v-btn @click="editFormUser(user)" depressed small color="primary"><v-icon>edit</v-icon></v-btn>
                  <v-btn @click="deleteUser(user)" depressed small color="error"><v-icon>delete</v-icon></v-btn>
                </td>
              </tr>
              <tr v-if="users.length === 0">
                <td align="center" style="height:50px;text-align:center" colspan="8">Belum ada data</td>
              </tr>
            </table>
          </v-flex>
        </v-layout>
        <template>

          <v-dialog v-model="dialogdeletealertuser" max-width="30%">
            <v-card>
              <v-card-title class="headline grey lighten-2 pt-2 pb-2" primary-title>
                Peringatan !
              </v-card-title>
              <v-card-text class="pt-2 pb-2">
                <v-layout row>
                  <v-flex xs12 d-flex>
                    <v-layout row>
                      <v-flex pb-1 xs12>
                        <v-layout row>
                          <v-flex pt-2 pr-2 xs12>
                            {{ msgalertuser }}
                          </v-flex>
                        </v-layout>
                      </v-flex>
                    </v-layout>
                  </v-flex>
                </v-layout>
              </v-card-text>
              <v-divider></v-divider>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" flat @click="dialogdeletealertuser = false">
                  Tutup
                </v-btn>
                <v-btn color="primary" flat @click="closeDeleteAlertUser()">
                  Yakin lah
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

        </template>
        <template>
          <v-dialog v-model="dialog_resetpassword" max-width="30%">
            <v-card>
              <v-card-title class="headline grey lighten-2 pt-2 pb-2" primary-title>
                Peringatan !
              </v-card-title>
              <v-card-text class="pt-2 pb-2">
                <v-layout row>
                  <v-flex xs12 d-flex>
                    <v-layout v-if="show_reason" row>
                      <v-flex pb-1 xs12>
                        <v-layout row>
                          <v-flex pt-2 pr-2 xs12>
                            Yakin, mau reset password user {{ selected_user.username }} ?
                          </v-flex>
                        </v-layout>
                        <v-layout row>
                          <v-flex pt-2 pr-2 xs12>
                            <v-textarea label="Tuliskan alasan di sini" v-model="reason"></v-textarea>
                            <p v-if="reason == ''" class="text--error">alasan harus diisi</p>
                          </v-flex>
                        </v-layout>
                      </v-flex>
                    </v-layout>
                    <v-layout v-if="!show_reason" row>
                      <v-flex pb-1 xs12>
                        <p>Reset password berhasil !!! </p>
                        <p>Password baru adalah <span class="mono" style="font-weight:bold;font-size:25px">{{ pass_reset
                        }}</span></p>
                      </v-flex>
                    </v-layout>
                  </v-flex>
                </v-layout>
              </v-card-text>
              <v-divider></v-divider>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" flat @click="dialog_resetpassword = false">
                  Tutup
                </v-btn>
                <v-btn color="green" flat v-if="reason !== '' && show_reason" @click="resetPasswordNow()">
                  Reset
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </template>
        <template>
          <v-layout row justify-center>
            <v-dialog v-model="dialoguser" persistent max-width="600px">
              <v-card>
                <v-card-title>
                  <span class="headline">Form User</span>
                </v-card-title>
                <v-form ref="formusergroupuser" v-model="validuser" lazy-validation>
                  <v-card-text class="pt-0 pb-0">
                    <v-layout wrap>
                      <v-flex xs12>
                        USER GROUP : {{ xusergroup.name }}
                      </v-flex>
                      <v-flex xs12>
                        <v-text-field label="User Name" v-model="username"></v-text-field>
                      </v-flex>



                      <v-flex xs12>
                        <v-text-field label="Password" v-model="password" type="password"></v-text-field>
                      </v-flex>

                      <v-flex xs12>
                        <v-autocomplete :search-input.sync="searchStaff" item-text="M_StaffName" return-object
                          :items="xstaffs" v-model="xstaff" label="Staff Name"></v-autocomplete>
                      </v-flex>

                      <!--<v-flex xs12>
                 <v-select item-text="T_SampleStationName" return-object :items="xsamplestationes"  v-model="xsamplestation" label="Sample Station" ></v-select>
                 </v-flex>-->

                      <v-flex xs12>
                        <v-select item-text="M_ApproveLevelName" return-object :items="xuserapprovelevels"
                          v-model="xuserapprovelevel" label="User Approve Level" clearable
                          @click:clear="xuserapprovelevel = {}"></v-select>
                      </v-flex>

                      <v-flex xs12>
                        <v-select item-text="R_ReportGroupName" return-object :items="xreportes" v-model="xreport"
                          label="Report Group"></v-select>
                      </v-flex>

                      <!-- <v-flex xs12>
                        <v-switch v-model="xuserlocationflag" true-value="R" false-value="B" color="blue"
                          :label="xuserlocationflag === 'R' ? 'REGIONAL' : 'CABANG'"></v-switch>
                      </v-flex> -->
                      <v-flex xs12>
                        <v-select item-text="M_UserLocationFlagName" return-object :items="xuserlocationflags"
                          v-model="xuserlocationflag" label="User Location"></v-select>
                      </v-flex>

                      <v-flex xs12>
                        <v-autocomplete label="Choose Regional" v-model="xregional" underlined :items="xregionals"
                          auto-select-first :disable="!xuserlocationflag" item-text="S_RegionalName"
                          item-value="S_RegionalID" return-object :loading="isLoading" :rules="[rules.regional]"
                          :error="errors.regional" no-data-text="Cari Regional ...">
                        </v-autocomplete>
                      </v-flex>

                      <v-flex xs12>
                        <v-select v-if="xuserlocationflag.M_UserLocationFlag == 'B'" item-text="M_BranchName"
                          item-value="M_BranchID" return-object :items="xbranches" v-model="xbranch"
                          label="Choose Branch" :disable="!xregional || xregional === null" no-filter
                          no-data-text="Pilih regional Dulu / Data Cabang Tidak ditemukan..."></v-select>
                      </v-flex>

                      <v-flex xs12>
                        <v-select :item-text="itemTextDivision" return-object :items="xuserdivisions" v-model="xuserdivision"
                          label="User Division" clearable @click:clear="xuserdivision = {}" :rules="[rules.division]" :error="errors.division" 
                          no-data-text="Pilih Divisi Dulu"></v-select>
                      </v-flex>
                      <!-- <v-flex xs12>
                        <v-autocomplete v-if="xuserlocationflag.M_UserLocationFlag == 'B'" label="Cabang"
                          v-model="xbranch" underlined :items="xbranches" :search-input.sync="search_branch"
                          auto-select-first :disable="!xuserlocationflag || !this.$store.state.usergroup.selected_regional"
                          item-text="M_BranchName" :rules="[rules.branch]" :error="errors.branch"
                          item-value="M_BranchID" return-object :loading="isLoading" no-data-text="Cari Cabang ...">
                        </v-autocomplete>
                      </v-flex> -->
                      <!--<v-flex xs12>
                 <v-checkbox v-model="iscoordinator" label="Coordinator ?"></v-checkbox>
                 </v-flex>-->

                      <v-flex>
                        <p v-for="(xerror, idx) in xerrors" class="error pl-2 pr-2" style="color:#fff">{{ xerror.msg }}
                        </p>
                      </v-flex>
                    </v-layout>
                  </v-card-text>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="updateDialogFormUser()">Tutup</v-btn>
                    <v-btn color="blue darken-1" flat
                      :disabled="validerror || this.errors.regional || this.errors.division || (xuserlocationflag.M_UserLocationFlag == 'B' && (_.isEmpty(xbranch)))"
                      @click="saveFormUser()">Simpan</v-btn>
                  </v-card-actions>
                </v-form>
              </v-card>
            </v-dialog>
          </v-layout>
        </template>

        <template>
          <v-layout row justify-center>
            <v-dialog v-model="dialoguseredit" persistent max-width="600px">
              <v-card>
                <v-card-title>
                  <span class="headline">Form User</span>
                </v-card-title>
                <v-form ref="formusergroupuser" v-model="validuser" lazy-validation>
                  <v-card-text class="pt-0 pb-0">
                    <v-layout wrap>

                      <v-flex xs12>
                        <v-select item-text="M_UserGroupName" return-object :items="xusergroupnames"
                          item-value="M_UserGroupID" v-model="xusergroupname" label="User Group"></v-select>
                      </v-flex>
                      <v-flex xs12>
                        <v-text-field label="User Name" v-model="username"></v-text-field>
                      </v-flex>



                      <v-flex xs12>
                        <v-autocomplete :search-input.sync="searchStaff" item-text="M_StaffName" return-object
                          :items="xstaffs" v-model="xstaff" label="Staff Name"></v-autocomplete>
                      </v-flex>

                      <v-flex xs12>
                        <v-select item-text="M_ApproveLevelName" return-object :items="xuserapprovelevels"
                          v-model="xuserapprovelevel" label="User Approve Level" clearable
                          @click:clear="xuserapprovelevel = {}"></v-select>
                      </v-flex>

                      <v-flex xs12>
                        <v-select item-text="R_ReportGroupName" return-object :items="xreportes" v-model="xreport"
                          label="Report Group"></v-select>
                      </v-flex>

                      <v-flex xs12>
                        <v-select item-text="M_UserLocationFlagName" return-object :items="xuserlocationflags"
                          v-model="xuserlocationflag" label="User Location"></v-select>
                      </v-flex>

                      <v-flex xs12>
                        <v-autocomplete label="Choose Regional" v-model="xregional" underlined :items="xregionals"
                          :search-input.sync="search_regional" auto-select-first :disable="!xuserlocationflag" no-filter
                          item-text="S_RegionalName" item-value="S_RegionalID" return-object :loading="isLoading"
                          :rules="[rules.regional]" :error="errors.regional" no-data-text="Cari Regional ...">
                        </v-autocomplete>
                      </v-flex>

                      <v-flex xs12>
                        <v-select v-if="xuserlocationflag.M_UserLocationFlag == 'B'" item-text="M_BranchName"
                          item-value="M_BranchID" return-object :items="xbranches" v-model="xbranch"
                          label="Choose Branch" :disable="!xregional || xregional === null"
                          no-data-text="Pilih regional Dulu / Data Cabang Tidak ditemukan..."></v-select>
                      </v-flex>

                      <v-flex xs12>
                        <v-select :item-text="itemTextDivision" return-object :items="xuserdivisions"
                          v-model="xuserdivision" label="User Division" clearable :rules="[rules.division]" :error="errors.division" 
                          @click:clear="xuserapprovelevel = {}"></v-select>
                      </v-flex>

                      <v-flex>
                        <p v-for="(xerror, idx) in xerrors" class="error pl-2 pr-2" style="color:#fff">{{ xerror.msg }}
                        </p>
                      </v-flex>
                    </v-layout>
                  </v-card-text>
                  <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="blue darken-1" flat @click="closeDialogEditUser()">Tutup</v-btn>
                    <v-btn color="blue darken-1" flat @click="saveEditUser()"
                      :disabled="validerror || this.errors.regional || this.errors.division || (xuserlocationflag.M_UserLocationFlag == 'B' && (_.isEmpty(xbranch) || xbranch == '0'))">Simpan
                      Perubahan</v-btn>
                  </v-card-actions>
                </v-form>
              </v-card>
            </v-dialog>
          </v-layout>
        </template>



      </v-card>
    </v-flex>



  </v-layout>
</template>

<style scoped>
.searchbox .v-input.v-text-field .v-input__slot {
  min-height: 60px;
}

.searchbox .v-btn {
  min-height: 60px;
}


table {
  font-family: arial, sans-serif;
  border-collapse: collapse;
  width: 100%;
  background: white;
  border: 0px;
}

th,
td {
  border: 1px solid black;
  border-collapse: collapse;
  padding-top: 2px;
  padding-bottom: 2px;
}

table>tr>td {
  padding: 8px;
}

table>tr>td:first {
  padding-left: 15px !important;
}
</style>

<script>
module.exports = {
  data() {
    return {
      searchStaff: '',
      query: "",
      search_regional: '',
      search_branch: '',
      validerror: false,
      items: [],
      rules: {
        regional: value => {
          this.errors.regional = !value.S_RegionalID; // Simpan status error
          return !!value.S_RegionalID || "Regional harus dipilih!";
        },
        division: value => {
          this.errors.division = !value.DivisionID; // Simpan status error
          return !!value.DivisionID || "Divisi harus dipilih!";
        },
        // branch: value => {
        //   if (this.$store.state.usergroup.selected_userlocationflag.M_UserLocationFlag === 'B') {
        //     if(value.M_BranchID == undefined){
        //       this.errors.branch = true;
        //       return "Regional harus dipilih!";
        //     }
        //     // Validasi branch
        //     console.log(value)
        //     this.errors.branch = !value.M_BranchID;
        //     return !!value.M_BranchID || "Branch harus dipilih!";
        //   }
        //   return true; // Jika userlocationflag bukan 'B', tidak ada validasi
        // }
      },
      headers: [
        {
          text: "USER NAME",
          align: "Center",
          sortable: false,
          value: "username",
          width: "30%",
          class: " blue lighten-4"
        },
        {
          text: "STAFF NAME",
          align: "Center",
          sortable: false,
          value: "staffname",
          width: "30%",
          class: "blue lighten-4"
        },
        {
          text: "PASSWORD",
          align: "Center",
          sortable: false,
          value: "password",
          width: "30%",
          class: "blue lighten-4"
        },

        {
          text: "Action",
          align: "Center",
          sortable: false,
          value: "status",
          width: "15%",
          class: "blue lighten-4"
        }
      ],
      isLoading: false,
      color: "success",
      validuser: false,
      xid: 0,
      username: "",
      selected_user: {},
      staffname: "",
      password: "",
      iscoordinator: "",
      dialogdeletealertuser: false,
      msgalertuser: ""
    };
  },
  computed: {
    errors: {
      get() {
        return this.$store.state.user.errors
      },
      set(val) {
        this.$store.commit('user/update_errors', val)
      }
    },
    xbranches() {
      return this.$store.state.usergroup.branches
    },
    xbranch: {
      get() {
        return this.$store.state.user.selected_branch
      },
      set(val) {
        // this.$store.commit("user/update_regional", val)
        var xval = val
        if (val.M_BranchID == undefined) {
          for (var i = 0; i < this.xbranches.length; i++) {
            var xs = this.xbranches[i]
            if (xs.M_BranchID == val) {
              xval = xs
            }
          }
        }
        this.$store.commit("user/update_selected_branch", xval)
      }
    },
    xregionals() {
      return this.$store.state.usergroup.regionals
    },
    xregional: {
      get() {
        return this.$store.state.user.selected_regional
      },
      set(val) {

        var xval = val
        if (val.S_RegionalID == undefined) {
          for (var i = 0; i < this.xregionals.length; i++) {
            var xs = this.xregionals[i]
            if (xs.S_RegionalID == val) {
              xval = xs
              let x = this.$store.state.user.selected_regional
              if (x) if (x.S_RegionalID) this.errors.regional = false
            }
          }
        }
        this.$store.commit("user/update_selected_regional", xval)
      }
    },
    pass_reset() {
      return this.$store.state.user.pass_reset
    },
    dialog_resetpassword: {
      get() {
        return this.$store.state.user.dialog_resetpassword
      },
      set(val) {
        this.$store.commit("user/update_dialog_resetpassword", val)
      }
    },
    reason: {
      get() {
        return this.$store.state.user.reason
      },
      set(val) {
        this.$store.commit("user/update_reason", val)
      }
    },
    show_reason: {
      get() {
        return this.$store.state.user.show_reason
      },
      set(val) {
        this.$store.commit("user/update_show_reason", val)
      }
    },
    dialoguseredit() {
      return this.$store.state.user.dialog_form_user_edit
    },
    users() {
      return this.$store.state.user.users
    },
    xusergroup() {
      return this.$store.state.usergroup.selected_usergroup
    },
    dialoguser() {
      return this.$store.state.user.dialog_form_user
    },
    xerrors() {
      return this.$store.state.user.errors
    },
    xsamplestationes() {
      return this.$store.state.usergroup.samplestations
    },
    xsamplestation: {
      get() {
        return this.$store.state.user.selected_samplestation
      },
      set(val) {
        var xval = val
        if (val.T_SampleStationID == undefined) {
          for (var i = 0; i < this.xsamplestationes.length; i++) {
            var xs = this.xsamplestationes[i]
            if (xs.T_SampleStationID == val) {
              xval = xs
            }
          }
        }
        this.$store.commit("user/update_selected_samplestation", xval)
      }
    },
    xstaffs() {
      return this.$store.state.usergroup.staffs
    },
    xstaff: {
      get() {
        return this.$store.state.user.selected_staff
      },
      set(val) {
        var xval = val
        if (val.M_StaffID == undefined) {
          for (var i = 0; i < this.xstaffs.length; i++) {
            var xs = this.xstaffs[i]
            if (xs.M_StaffID == val) {
              xval = xs
            }
          }
        }
        this.$store.commit("user/update_selected_staff", xval)
      }
    },
    xusergroupnames() {
      return this.$store.state.usergroup.usergroupnames
    },
    xusergroupname: {
      get() {
        return this.$store.state.user.selected_usergroupname
      },
      set(val) {
        var xval = val
        if (val.M_UserGroupID == undefined) {
          for (var i = 0; i < this.xusergroupnames.length; i++) {
            var xs = this.xusergroupnames[i]
            if (xs.M_UserGroupID == val) {
              xval = xs
            }
          }
        }
        this.$store.commit("user/update_selected_usergroupname", xval)
      }
    },
    xuserlocationflags() {
      return this.$store.state.usergroup.userlocationflags
    },
    xuserlocationflag: {
      get() {
        return this.$store.state.user.selected_userlocationflag
      },
      set(val) {
        var xval = val
        console.log("xval", val)
        if (val.M_UserLocationFlag == undefined) {
          console.log("xval2", val)
          for (var i = 0; i < this.xuserlocationflags.length; i++) {
            var xs = this.xuserlocationflags[i]
            if (xs.M_UserLocationFlag == val) {
              xval = xs
              console.log("xva3", val)
            }
          }
        }
        this.$store.commit("user/update_selected_userlocationflag", xval)
        if (val.M_UserLocationFlag == "R") {
          this.$store.commit("user/update_selected_branch", {})
        }
      }
    },
    xuserapprovelevels() {
      return this.$store.state.usergroup.approvelevels
    },
    xuserapprovelevel: {
      get() {
        return this.$store.state.user.selected_userapprovelevel
      },
      set(val) {
        var xval = val
        console.log("xapprovelevel1", val)
        if (val.M_ApproveLevelID == undefined) {
          console.log("xapprovelevel12", val)
          for (var i = 0; i < this.xuserapprovelevels.length; i++) {
            var xs = this.xuserapprovelevels[i]
            if (xs.M_ApproveLevelID == val) {
              xval = xs
              console.log("xapprovelevel13", val)
            }
          }
        }
        this.$store.commit("user/update_selected_userapprovelevel", xval)
        // if (val.M_UserLocationFlag == "R") {
        //   this.$store.commit("user/update_selected_branch", {})
        // }
      }
    },
    xuserdivisions() {
      return this.$store.state.usergroup.divisions
    },
    xuserdivision: {
      get() {
        return this.$store.state.user.selected_userdivision
      },
      set(val) {
        var xval = val
        console.log("division", val)
        if (val.DivisionID == undefined) {
          console.log("xdivision2", val)
          for (var i = 0; i < this.xuserdivisions.length; i++) {
            var xs = this.xuserdivisions[i]
            if (xs.DivisionID == val) {
              xval = xs
              let x = this.$store.state.user.selected_userdivision
              if (x) if (x.DivisionID) this.errors.division = false
              console.log("xdivision3", val)
            }
          }
        }
        this.$store.commit("user/update_selected_userdivision", xval)
        // if (val.M_UserLocationFlag == "R") {
        //   this.$store.commit("user/update_selected_branch", {})
        // }
      }
    },
    xreportes() {
      return this.$store.state.usergroup.reports
    },
    xreport: {
      get() {
        return this.$store.state.usergroup.selected_report
      },
      set(val) {
        var xval = val
        if (val.R_ReportGroupID == undefined) {
          for (var i = 0; i < this.xreportes.length; i++) {
            var xs = this.xreportes[i]
            if (xs.R_ReportGroupID == val) {
              xval = xs
            }
          }
        }
        this.$store.commit("usergroup/update_selected_report", xval)
      }
    }


  },
  methods: {
    resetPasswordNow() {
      var param = this.selected_user
      param.reason = this.reason
      this.$store.dispatch("user/resetPassword", param)
    },
    resetPassword(value) {
      this.selected_user = value
      this.reason = ''
      this.show_reason = true
      this.dialog_resetpassword = true
    },
    updateDialogFormUser() {
      this.$store.commit("user/update_dialog_form_user", false)
    },
    itemTextDivision(item) {
      return `${item.DivisionCode} - ${item.DivisionName}`;
    },
    openFormUser(val) {
      this.xid = val
      this.username = ''

      this.xuserapprovelevel = {}
      this.xuserdivision = {}
      this.password = ''
      this.xstaff = ''
      this.xsamplestation = ''
      this.xuserlocationflag = { M_UserLocationFlagName: 'REGIONAL', M_UserLocationFlag: 'R' }
      this.xregional = {}
      this.xbranch = {}
      this.xapprovelevel = {}
      this.xreport = ''
      this.iscoordinator = ''
      this.$store.commit("user/update_dialog_form_user", true)
    },
    editFormUser(val) {
      this.$store.dispatch("usergroup/getreportsample")
      this.$store.commit("user/update_error_username", false)
      this.$store.commit("user/update_error_password", false)
      this.$store.commit("user/update_error_xstaff", false)
      this.$store.commit("user/update_error_xsamplestation", false)
      this.$store.commit("user/update_error_xreport", false)
      this.$store.commit("user/update_error_xusergroupname", false)
      this.$store.commit("user/update_error_iscoordinator", false)
      this.xid = val.id
      this.username = val.username

      this.password = val.password
      // this.xbranch = val.xbranch
      this.$store.commit("usergroup/update_branches", [{
        M_BranchID: val.xbranch,
        M_BranchName: val.M_BranchName
      }])
      this.$store.commit("user/update_selected_branch", {
        M_BranchID: val.xbranch,
        M_BranchName: val.M_BranchName
      })
      this.$store.commit("user/update_selected_userapprovelevel", {
        M_ApproveLevelID: val.xapprovelevelid,
        M_ApproveLevelName: val.xapprovelevelname,
      })
      this.$store.commit("user/update_selected_userdivision", {
        DivisionID: val.xuserdivisonid,
        DivisionCode: val.xuserdivisioncode,
        DivisionName: val.xuserdivisionname,
      })
      // this.xregional = val.xregional
      this.$store.commit("usergroup/update_regionals", [{
        S_RegionalID: val.xregional,
        S_RegionalName: val.S_RegionalName
      }])
      this.$store.commit("user/update_selected_regional", {
        S_RegionalID: val.xregional,
        S_RegionalName: val.S_RegionalName
      })
      // this.xstaff = val.xstaff
      this.$store.commit("usergroup/update_staffs", [{
        M_StaffID: val.xstaff,
        M_StaffName: val.staffname
      }])
      this.$store.commit("user/update_selected_staff", {
        M_StaffID: val.xstaff,
        M_StaffName: val.staffname
      })
      if (val.M_UserLocationFlag == 'B') {
        this.xuserlocationflag = { M_UserLocationFlag: val.M_UserLocationFlag, M_UserLocationFlagName: 'CABANG' }
      } else if (val.M_UserLocationFlag == 'R') {
        this.xuserlocationflag = { M_UserLocationFlag: val.M_UserLocationFlag, M_UserLocationFlagName: 'REGIONAL' }
      }

      this.xsamplestation = val.xsamplestation
      // this.xreport = val.xreport
      this.$store.commit("usergroup/update_reports", [{
        R_ReportGroupID: val.xreport,
        R_ReportGroupName: val.R_ReportGroupName
      }])
      this.$store.commit("usergroup/update_selected_report", {
        R_ReportGroupID: val.xreport,
        R_ReportGroupName: val.R_ReportGroupName
      })
      this.xusergroupname = val.usergroupid
      this.iscoordinator = val.iscoordinator === 'N' ? false : true
      this.$store.commit("user/update_dialog_form_user_edit", true)
    },
    closeDialogEditUser() {
      this.$store.commit("user/update_dialog_form_user_edit", false)
      this.$store.dispatch("usergroup/getreportsample")
    },
    saveEditUser() {
      this.$store.dispatch("user/save_edit", {
        xid: this.xid,
        usergroupid: this.$store.state.usergroup.selected_usergroup.id,
        usergroupname: this.$store.state.usergroup.selected_usergroup.name,
        username: this.username,
        xregional: this.$store.state.user.selected_regional.S_RegionalID,
        userlocationflag: this.$store.state.user.selected_userlocationflag.M_UserLocationFlag,
        xbranch: this.$store.state.user.selected_branch.M_BranchID,
        xapprovelevel: this.$store.state.user.selected_userapprovelevel.M_ApproveLevelID,
        xdivision: this.$store.state.user.selected_userdivision.DivisionID,

        xstaff: this.xstaff,
        xsamplestation: this.xsamplestation,
        xreport: this.xreport,
        xusergroupname: this.xusergroupname,
        iscoordinator: this.iscoordinator === true ? "Y" : "N"
      })
    },
    saveFormUser() {
      this.$store.dispatch("user/save", {
        xid: this.xid,
        usergroupid: this.$store.state.usergroup.selected_usergroup.id,
        usergroupname: this.$store.state.usergroup.selected_usergroup.name,
        username: this.username,

        xregional: this.$store.state.user.selected_regional.S_RegionalID,
        userlocationflag: this.$store.state.user.selected_userlocationflag.M_UserLocationFlag,
        xbranch: this.$store.state.user.selected_branch.M_BranchID,
        xapprovelevel: this.$store.state.user.selected_userapprovelevel.M_ApproveLevelID,
        xdivision: this.$store.state.user.selected_userdivision.DivisionID,

        password: this.password,
        xstaff: this.xstaff,
        xsamplestation: this.xsamplestation,
        xreport: this.xreport,
        iscoordinator: this.iscoordinator === true ? "Y" : "N"
      })
    },
    updateAlert_success(val) {
      this.$store.commit("usergroup/update_alert_success", val)
    },
    deleteUser(data) {
      this.xid = data.id
      this.msgalertuser = "Yakin, mau hapus user ?"
      this.dialogdeletealertuser = true
    },
    closeDeleteAlertUser() {
      this.$store.dispatch("user/delete", {
        xid: this.xid,
        usergroupid: this.$store.state.usergroup.selected_usergroup.id,
        usergroupname: this.$store.state.usergroup.selected_usergroup.name,
        username: this.username
      })
      this.dialogdeletealertuser = false
    },
    thr_search_regional: _.debounce(function () {
      this.$store.dispatch("usergroup/search_regional", { search: this.search_regional })
    }, 2000),
    thr_search_branch: _.debounce(function () {
      this.$store.dispatch("usergroup/search_branch", { regionalid: this.$store.state.user.selected_regional.S_RegionalID })
    }, 1000),
  },
  watch: {
    xregional(val, old) {
      if (val == old) return
      if (!val) return
      if (val.length < 1) return
      if (this.$store.state.usergroup.update_autocomplete_status == 1) return
      //this.selected_icd10 = {}
      // this.$store.commit("user/update_selected_branch", {})
      this.thr_search_branch()
    },
  }
}
</script>
